/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include "mptree.h"

extern char *NO_ARTIST;
extern char *NO_ALBUM;
extern char *NO_TITLE;
extern char *SNDTRACKS;

void new_database()
{
  GtkCTreeNode *c_artist, *nartist;

  c_artist = GTK_CTREE_ROW(root)->children;
  if (c_artist)
  {
    clear_sl();
    clear_medialist();

    gtk_widget_hide(ctree);
    do {
      nartist = GTK_CTREE_ROW(c_artist)->sibling;
      delete_artist(GTK_CTREE(ctree), c_artist, NULL);
      c_artist = nartist;
    } while (c_artist);
    gtk_widget_show(ctree);

    sndt_root = NULL;
    selected_tree_item = NULL;

    gtk_ctree_set_node_info(GTK_CTREE(ctree), root, "New Database", 5,
                           GTK_PIXMAP(dbicon)->pixmap, NULL,
                           GTK_PIXMAP(dbicon)->pixmap, NULL,
                           FALSE, TRUE);
  }
}

void savedb(char *fileName)
{
  GtkCTreeNode *c_artist, *c_album, *c_song;
  additional_info *ainfo=NULL;
  FILE *fd;
  char year[5];
  char *cur_sndt_artist=NULL, *cur_sndt_songname=NULL;
  char i;
  short tmp;
  int d, h, m, s;

  fd = fopen(fileName, "wb");

  fwrite(&max_row_medialist, sizeof(short), 1, fd);

  for(i=0;i<=max_row_medialist;i++)
  {
    fputc((char) strlen(get_media_name(i)), fd);
    fputs(get_media_name(i), fd);
    tmp = get_media_sc(i);
    fwrite(&tmp, sizeof(short), 1, fd);
    tmp = get_media_size(i);
    fwrite(&tmp, sizeof(short), 1, fd);
    sscanf(get_media_length(i), "%02dd%02dh%02dm%02ds", &d, &h, &m, &s);
    fputc((char) d, fd);
    fputc((char) h, fd);
    fputc((char) m, fd);
    fputc((char) s, fd);
  }
  fputc(0, fd);

  c_artist = GTK_CTREE_ROW(root)->children;

    do {
      c_album = GTK_CTREE_ROW(c_artist)->children;
      if (!strcmp(get_node_text(c_artist), NO_ARTIST)) {
        fputc('r', fd);
      } else if (c_artist != sndt_root) {
        fputc('R', fd);
        fputc((char) strlen(get_node_text(c_artist)), fd);      // writes length of artist to stream
        fputs(get_node_text(c_artist), fd);
      } else putc('T', fd);
      do {
          c_song = GTK_CTREE_ROW(c_album)->children;
          if (!strcmp(get_node_text(c_album), NO_ALBUM)) {
             fputc('a', fd);
          } else {
             fputc('A', fd);
             fputc((char) strlen(get_node_text(c_album)), fd);      // writes length of artist to stream
             fputs(get_node_text(c_album), fd);
          }
          do {
              ainfo = gtk_ctree_node_get_row_data(GTK_CTREE(ctree), c_song);
              fputc('S', fd);

              if (c_artist == sndt_root) {
	        cur_sndt_artist = get_artist_by_node(c_song);
		cur_sndt_songname = get_title(c_song);
		
		fputc((char) strlen(cur_sndt_songname), fd);
		fputc((char) strlen(ainfo->filename), fd);

		if (ainfo->comment)
		  fputc((char) strlen(ainfo->comment), fd);
		else fputc(0, fd); 
		
		if (cur_sndt_artist!=NULL) {
		  fputc((char) strlen(cur_sndt_artist), fd);
		}
		else fputc(0, fd);

		fputs(cur_sndt_songname, fd);
		
		if (cur_sndt_artist!=NULL) {
		fputs(cur_sndt_artist, fd);
		}
		
		free(cur_sndt_songname);
		free(cur_sndt_artist);
	      } else {
                fputc((char) strlen(get_title(c_song)), fd);
                fputc((char) strlen(ainfo->filename), fd);
                if (ainfo->comment)
                  fputc((char) strlen(ainfo->comment), fd);
                else fputc(0, fd);
                fputs(get_title(c_song), fd);
	      }
              fputc(ainfo->genre, fd);
              if ((!ainfo->year) || (strlen(ainfo->year) != 4))
                strcpy(year, "    ");
              else strcpy(year, ainfo->year);
              fputs(year, fd);
              fwrite(&(ainfo->s_length), sizeof(short), 1, fd);
              fwrite(&(ainfo->onmedia), sizeof(short), 1, fd);
              fputs(ainfo->filename, fd);
              if (ainfo->comment)
              {
                fputs(ainfo->comment, fd);
              }
              c_song = GTK_CTREE_ROW(c_song)->sibling;
          } while (c_song);
          c_album = GTK_CTREE_ROW(c_album)->sibling;
      } while (c_album);
      c_artist = GTK_CTREE_ROW(c_artist)->sibling;
    } while (c_artist);
    gtk_ctree_set_node_info(GTK_CTREE(ctree), root, fileName, 5,
                                 GTK_PIXMAP(dbicon)->pixmap, NULL,
                                 GTK_PIXMAP(dbicon)->pixmap, NULL,
                                 FALSE, TRUE);
    fclose(fd);
}


void loaddb(char *fileName)
{
  GtkCTreeNode *c_artist=NULL, *c_album=NULL, *c_song=NULL;
  static additional_info *ainfo=NULL;
  FILE *fd;
  static char *buf=NULL;
  char *sndt_songname, *sndt_artist;
  unsigned char length=-1, itemtype;
  unsigned char alength, nlength, flength, clength;
  unsigned short ilength;
  unsigned int sc=0;
  char *text[2], *ml[6];
  short tmp;
  int mbc=0;		// counts size of all media in mb
  float msl=0;	// songlength of all media in hours
  char d, h, m, s;
  char trackn;		// number of the track

  text[1] = NULL;
  fd = fopen(fileName, "rb");

  fread(&max_row_medialist, sizeof(short), 1, fd);	// ignore media-count
  while ((feof(fd) == 0) && (length != 0))
  {
	  length = fgetc(fd);
	  if (length != 0) {
		  buf = (char *) malloc (length+1);
		  fgets(buf, length+1, fd);
		  fflush(stdout);
		  ml[1] = (char *) malloc (10);
		  ml[2] = (char *) malloc (10);
		  ml[3] = (char *) malloc (14);
		  ml[5] = NULL;
		  ml[0] = buf;
		  ml[4] = "";
		  fread(&tmp, sizeof(short), 1, fd);
		  sprintf(ml[1], "%d", (int) tmp);
		  fread(&tmp, sizeof(short), 1, fd);
		  mbc = mbc + tmp;
		  sprintf(ml[2], "%dMB", (int) tmp);
		  d = fgetc(fd);
		  h = fgetc(fd);
		  m = fgetc(fd);
		  s = fgetc(fd);
		  sprintf(ml[3], "%02dd%02dh%02dm%02ds", d, h, m, s);
		  msl = msl + d*24 + h + m/60;
		  add_medialist_item(ml);
	  }
  }
  if (feof(fd) != 0) {
	  fprintf(stderr, "file incomplete/damaged\n");
	  fclose(fd);
	  return;
  }


  gtk_widget_hide(ctree);
  itemtype = fgetc(fd);
  while (feof(fd) == 0)
  {
	  switch (itemtype)
	  {
		  case 'T':	// soundtrack/compilation : no further length needed
			  if (!sndt_root) {
				  text[0] = SNDTRACKS;
				  sndt_root = gtk_ctree_insert_node(GTK_CTREE(ctree), root, NULL, text, 5,
						  GTK_PIXMAP(artisticon)->pixmap, NULL,
						  GTK_PIXMAP(artisticon)->pixmap, NULL,
						  FALSE, FALSE);
			  }
			  c_artist = sndt_root;
			  break;
		  case 'r':	// no artist
			  c_artist = my_find_tree_node(root, NO_ARTIST);
			  if (!c_artist) {
				  text[0] = NO_ARTIST;
				  c_artist = gtk_ctree_insert_node(GTK_CTREE(ctree), root, NULL, text, 5,
						  GTK_PIXMAP(artisticon)->pixmap, NULL,
						  GTK_PIXMAP(artisticon)->pixmap, NULL,
						  FALSE, FALSE);
			  }
			  break;
		  case 'R':
			  length = fgetc(fd);
			  buf = (char *) malloc (length+1);
			  fgets(buf, length+1, fd);
			  text[0] = buf;
			  c_artist = NULL;
			  c_artist = gtk_ctree_insert_node(GTK_CTREE(ctree), root, NULL, text, 5,
					  GTK_PIXMAP(artisticon)->pixmap, NULL,
					  GTK_PIXMAP(artisticon)->pixmap, NULL,
					  FALSE, FALSE);
			  break;
		  case 'a':	// no album
			  c_album = my_find_tree_node(c_artist, NO_ALBUM);
			  if (!c_album) {
				  text[0] = NO_ALBUM;
				  c_album = gtk_ctree_insert_node(GTK_CTREE(ctree), c_artist, NULL, text, 5,
						  GTK_PIXMAP(albumicon)->pixmap, NULL,
						  GTK_PIXMAP(albumicon)->pixmap, NULL,
						  FALSE, FALSE);
			  }
			  break;
		  case 'A':
			  length = fgetc(fd);
			  buf = (char *) malloc (length+10);
			  fgets(buf, length+1, fd);
			  text[0] = buf;
			  c_album = NULL;
			  c_album = gtk_ctree_insert_node(GTK_CTREE(ctree), c_artist, NULL, text, 5,
					  GTK_PIXMAP(albumicon)->pixmap, NULL,
					  GTK_PIXMAP(albumicon)->pixmap, NULL,
					  FALSE, FALSE);
			  break;
		  case 'S':
			  sc = sc +1;
			  ainfo = (additional_info *) malloc (sizeof(additional_info));
			  ainfo->artist = NULL;
			  nlength = fgetc(fd);
			  flength = fgetc(fd);
			  clength = fgetc(fd);
			  if (c_artist == sndt_root) {
				  alength = fgetc(fd);
			  } else alength = 0;
			  if (nlength > 0) {	
			    buf = (char *) malloc (nlength+1);
			    fgets(buf, nlength+1, fd);
			  } else buf = NO_TITLE;
			  if (c_artist == sndt_root) {
				  sndt_songname = buf;
				  if (alength > 0) {
					  sndt_artist=(char *) malloc (alength+1);
					  fgets(sndt_artist, alength+1, fd);
				  }
				  else 
			  	  {
					  sndt_artist = (char *) malloc (strlen(NO_ARTIST));
					  strcpy(sndt_artist, NO_ARTIST);
					  alength = strlen(NO_ARTIST);
				  }
				  buf = (char *) malloc (nlength+alength+4);
				  sprintf(buf, "%s [%s]", sndt_songname, sndt_artist);
				  ainfo->artist = buf+nlength+2;
				  free(sndt_songname);
				  free(sndt_artist);
			  }  
			  text[0] = buf;
			  
			  ainfo->genre = fgetc(fd);
			  buf = (char *) malloc (6);
			  fgets(buf, 5, fd);
			  ainfo->year = buf;
			  fread(&ilength, sizeof(short), 1, fd);
			  ainfo->s_length = ilength;
			  fread(&ilength, sizeof(short), 1, fd);
			  ainfo->onmedia = ilength;
			  buf = (char *) malloc (flength+1);
			  fgets(buf, flength+1, fd);
			  ainfo->filename = buf;
			  if (clength>0)
			  {
				  buf = (char *) malloc (clength+1);
				  fgets(buf, clength+1, fd);
				  ainfo->comment = buf;
			  }
			  else ainfo->comment=NULL;
			  trackn = get_tracknumber(ainfo->filename);
			  if (trackn) {
			    buf = (char *) malloc (strlen(text[0])+5);
			    sprintf(buf, "%02d. %s", trackn, text[0]);
			    free(text[0]);
			    ainfo->has_trackn = TRUE;
			    if (c_artist == sndt_root) {
			      ainfo->artist = buf+nlength+6;
			    }

			    text[0] = buf;
			  } else ainfo->has_trackn = FALSE;

			  c_song = gtk_ctree_insert_node(GTK_CTREE(ctree), c_album, NULL, text, 5,
					  GTK_PIXMAP(songicon)->pixmap, NULL,
					  GTK_PIXMAP(songicon)->pixmap, NULL,
					  FALSE, FALSE);	
			  gtk_ctree_node_set_row_data(GTK_CTREE(ctree), c_song, ainfo);
			  break; 
		  default:
			  fprintf(stderr, "file incomplete/damaged\n");
			  fclose(fd);
			  gtk_widget_show(ctree);
			  return;
	  }
	  itemtype = fgetc(fd);
  }
  gtk_ctree_set_node_info(GTK_CTREE(ctree), root, fileName, 5,
		  GTK_PIXMAP(dbicon)->pixmap, NULL,
		  GTK_PIXMAP(dbicon)->pixmap, NULL,
		  FALSE, TRUE);
  gtk_widget_show(ctree);
  fclose(fd);
  sprintf(message, "%d songs loaded from %s (~%.2fGB, ~%.1fh)", sc, fileName, 
  	  (float) mbc / 1024, msl);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, message);
}

char *get_whole_path(GtkCTreeNode *song)
{
  additional_info *info=NULL;
  char *whole_path;

  if ((info = gtk_ctree_node_get_row_data(GTK_CTREE(ctree), GTK_CTREE_NODE(song)))) {
    if (strlen(get_media_path(info->onmedia)) > 0)
      {
	whole_path = (char *) malloc (strlen(info->filename)+strlen(get_media_path(info->onmedia))+2);
        strcpy(whole_path, get_media_path(info->onmedia));
        strcat(whole_path, "/");
        strcat(whole_path, info->filename);

	return whole_path;
      }
    }
  return NULL;
}

void get_statistics(GtkCTreeNode *node, char *medium, int *sc)
{
  GtkCTreeNode *c_artist, *c_album, *c_song;
  additional_info *ainfo;

  c_artist = GTK_CTREE_ROW(node)->children;
  if (!c_artist) return;

  do {
    c_album = GTK_CTREE_ROW(c_artist)->children;
    do {
      c_song = GTK_CTREE_ROW(c_album)->children;
      do {
        ainfo = gtk_ctree_node_get_row_data(GTK_CTREE(ctree), c_song);
	if ((medium == NULL) || (ainfo->onmedia == *medium))
	{
	  *sc = *sc + 1;
	}
        c_song = GTK_CTREE_ROW(c_song)->sibling;
      } while (c_song);
      c_album = GTK_CTREE_ROW(c_album)->sibling;
    } while (c_album);
    c_artist = GTK_CTREE_ROW(c_artist)->sibling;
  } while (c_artist);
}
