/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include "mptree.h"

GtkWidget *songList;

void create__list(GtkWidget *list)
{
   GtkWidget *scrollwin, *mainbox;
   char *text[] = { "N", "Title", "Artist", "Time", };

   mainbox = gtk_vbox_new(FALSE, 3);
   gtk_container_add(GTK_CONTAINER(list), mainbox);

   scrollwin = gtk_scrolled_window_new(NULL, NULL);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(scrollwin), 
     GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

   gtk_box_pack_start(GTK_BOX(mainbox), scrollwin, TRUE, TRUE, TRUE);

   songList = gtk_clist_new_with_titles(4, text);
   gtk_clist_set_column_auto_resize (GTK_CLIST(songList), 0, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(songList), 1, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(songList), 2, TRUE);
   gtk_clist_set_column_auto_resize (GTK_CLIST(songList), 3, TRUE);
   gtk_container_add(GTK_CONTAINER(scrollwin), songList); 

   gtk_signal_connect(GTK_OBJECT(songList), "select_row", 
   	GTK_SIGNAL_FUNC(songlist_row_selected), NULL);
   gtk_signal_connect(GTK_OBJECT(songList), "button_press_event",
        GTK_SIGNAL_FUNC(songlist_rightmouse_pressed), NULL);

}

void add_songlist_item(GtkCTreeNode *node)	// without N
{
  char *text[5];
  additional_info *info=NULL;
  char days, hours, minutes, seconds;

  text[0] = (char *) malloc(4);
  text[3] = (char *) malloc(6);
  songlist_count = songlist_count + 1;
  sprintf(text[0], "%02d", songlist_count); 
  info = gtk_ctree_node_get_row_data(GTK_CTREE(ctree), GTK_CTREE_NODE(node));
  text[1] = get_title(node);
  text[2] = get_artist_by_node(node);
  dhms_time(info->s_length, &days, &hours, &minutes, &seconds);
  sprintf(text[3], "%02d:%02d", (hours+days*24)*60+minutes, seconds);
  gtk_clist_append(GTK_CLIST(songList), text);
  gtk_clist_set_row_data(GTK_CLIST(songList), songlist_count-1, node);
}

void songlist_row_selected(GtkCList *clist, gint row,
	gint column)
{
  GtkCTreeNode *node;

  selected_slitem = row;
  node = gtk_clist_get_row_data(GTK_CLIST(clist), row);
  tree_item_selected(ctree, (GtkWidget *) node); 
}

void songlist_rightmouse_pressed (GtkWidget *widget, GdkEventButton *event)
{
   if (event->button == 3) //right Mousebutton
   {
      GtkItemFactory *popup_itemfactory;
      GtkWidget *popmenu;
      GtkAccelGroup *accel_group;
      gint row=-1, col, numb_of_items;
      GtkItemFactoryEntry menu_items[] = {
         { "/Move _up", NULL, sl_move_up, 0, NULL },
         { "/Move _down", NULL, sl_move_down, 0, NULL} 
      };

      gtk_clist_get_selection_info (GTK_CLIST(widget), event->x, event->y, &row, &col);

      gtk_clist_select_row(GTK_CLIST(songList), row, col);
      selected_slitem=row;

      numb_of_items = sizeof (menu_items) / sizeof(menu_items[0]);
      accel_group = gtk_accel_group_new ();
      popup_itemfactory = gtk_item_factory_new (GTK_TYPE_MENU, "<slpopup>", accel_group);
      gtk_item_factory_create_items (popup_itemfactory, numb_of_items, menu_items, NULL);
      gtk_accel_group_attach (accel_group, GTK_OBJECT (mainwin));
      popmenu = gtk_item_factory_get_widget (popup_itemfactory, "<slpopup>");

      gtk_menu_popup( GTK_MENU(popmenu), NULL, NULL, NULL, NULL, event->button, event->time);
  }
}

void sl_move_up()
{
  char *text;

  int row = selected_slitem;
  if (row != 0) {
    gtk_clist_row_move(GTK_CLIST(songList), row, row-1);
    text = (char *) malloc(4);
    sprintf(text, "%02d", selected_slitem);
    selected_slitem = row-1;
    gtk_clist_set_text(GTK_CLIST(songList), selected_slitem, 0, text);
    text = (char *) malloc(4);
    sprintf(text, "%02d", row+1);
    gtk_clist_set_text(GTK_CLIST(songList), selected_slitem+1, 0, text); 
  }
}

void sl_move_down()
{
  char *text;

  int row = selected_slitem;
  if (row != songlist_count-1) {
    gtk_clist_row_move(GTK_CLIST(songList), row, row+1);
    text = (char *) malloc(4);
    sprintf(text, "%02d", selected_slitem+2);
    selected_slitem = row+1;
    gtk_clist_set_text(GTK_CLIST(songList), selected_slitem, 0, text);
    text = (char *) malloc(4);
    sprintf(text, "%02d", row+1);
    gtk_clist_set_text(GTK_CLIST(songList), selected_slitem-1, 0, text); 
  }
}

void add_sl_to_epl()
{
  int counter;

  for(counter=0;counter<=songlist_count+1;counter++)
    send_song_to_external_playlist((GtkCTreeNode *) 
    	gtk_clist_get_row_data(GTK_CLIST(songList), counter));
}

void clear_sl()
{
  gtk_clist_clear(GTK_CLIST(songList));
  songlist_count = 0;
}

void sl_remove_item()
{
  gtk_clist_remove(GTK_CLIST(songList), selected_slitem);
  songlist_count = songlist_count - 1;
}

unsigned int sum_sl_totaltime()
{
  additional_info  *ainfo;
  GtkCTreeNode *node;
  unsigned int ttime=0, i;
  
  for(i=0;i < songlist_count;i++)
  {
    node = gtk_clist_get_row_data(GTK_CLIST(songList), i);
    ainfo = gtk_ctree_node_get_row_data(GTK_CTREE(ctree), node);

    ttime = ttime + ainfo->s_length;
  }
  return ttime;
}
